
/***************************************************************************
  par UTPECA d'après Rui Santos
  Complete project details at 
  https://RandomNerdTutorials.com/esp32-async-web-server-espasyncwebserver-library/
  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.
****************************************************************************/

// Import required libraries
#include <WiFi.h>
#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>

#define DEBUG
#define NBMOT 8

// Connection au routeur wifi (la box)
const char* ssid     = "... le nom de votre routeur ...";
const char* password = "... votre mot de passe ...";

// communication entre le serveur et la page HTML (browser)
const char* PARAM_INPUT_1 = "output"; // Nom de l'appareil
const char* PARAM_INPUT_2 = "state";  // Etat de l'appareil

// Adresse du site ou sont stockees les images
String        img_Web   = "http://utpeca.free.fr/TCO/"; 

// Gestion des 74HC595
const    byte verrou     = 2;     // ST_CP (latch)
const    byte donnee     = 4;     // DS (data)
const    byte horloge    = 0;     // SH_CP (clock)
         uint16_t u_Data = 0b0101010101010101;     // data pour les 74hc595
const    uint16_t k_Msk  = 0b1100000000000000;     // Masque
const    uint16_t k_Dir  = 0b0100000000000000;     // Moteur direct
const    uint16_t k_Dev  = 0b1000000000000000;     // Moteur dévié

// Create AsyncWebServer object on port 80
AsyncWebServer server(80);

const char index_html[] PROGMEM = R"rawliteral(
<!DOCTYPE HTML><html>
<head>
  <title>TCO par UTPECA</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="icon" href="data:,">
  <style>
    html {font-family: Arial; display: inline-block; text-align: left;}
    h2 {font-size: 3.0rem;}
    p {font-size: 15px; font-weight: bold; width: 400px; margin-left: 30px; padding-bottom: 2px; padding-top: 2px; border: 2px solid #6B6B94}
    .img1 {border: 0px; width: 64px; height=64px;}
    body {max-width: 1280px; margin:0px auto; padding-bottom: 10px; padding-top: 10px;}
  </style>
</head>
<body background='http://utpeca.free.fr/TCO/Pierre.gif' >
<table border='0' width='1280' cellspacing='0' cellpadding='0'>
<tr><td><img border='0' src='%IMAGE_WEB%Titre2.gif'</td></tr>
<tr><td><img border='0' src='%IMAGE_WEB%Ligne.gif'</td></tr></table>
 
%CONSTRUIRE_TCO%

<table><tr><td><img border='0' src='%IMAGE_WEB%Ligne.gif'</td></tr></table>
<p id='DESC'> &nbsp;Manoeuvrez un appareil</p>
<table><tr><td><img border='0' src='%IMAGE_WEB%Ligne.gif'</td></tr></table>

<script>
var imgWeb  = '%IMAGE_WEB%';
var posApp1 = '%VALEUR_APP1%';
var posApp2 = '%VALEUR_APP2%';
var posApp3 = '%VALEUR_APP3%';
var posApp4 = '%VALEUR_APP4%';
var posApp5 = '%VALEUR_APP5%';
var posApp6 = '%VALEUR_APP6%';
var posApp7 = '%VALEUR_APP7%';
var posApp8 = '%VALEUR_APP8%';

function ChangeAig(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'.png';
   } 
   else
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'_'+angApp+'.png';
   }
   xhr.open("GET", "/update?output="+kodApp+":A&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeAigS(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; droite";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; gauche";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'.png';
   } 
   else
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'_'+angApp+'.png';
   }
   xhr.open("GET", "/update?output="+kodApp+":S&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeAigT(posApp, kodApp, imgApp, angApp)
{
   var posAig = posApp;
   var xhr = new XMLHttpRequest();
   if ( posAig == "1" )
   {
      posAig = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; gauche";
   }
   else if ( posAig == "2" )
   {
      posAig = "3";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e &agrave; droite";
   }
   else
   {
      posAig = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'.png';
   } 
   else
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posAig+'_'+angApp+'.png';
   }
   xhr.open("GET", "/update?output="+kodApp+":T&state="+posAig, true);
   xhr.send();
   return posAig;
}

function ChangeTjd(posApp, kodApp, imgApp, angApp)
{
   var posTjd = posApp;
   var xhr = new XMLHttpRequest();
   if ( posTjd == "1" )
   {
      posTjd = "2";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else if ( posTjd == "2" )
   {
      posTjd = "3";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   else if ( posTjd == "3" )
   {
      posTjd = "4";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie d&eacute;vi&eacute;e";
   }
   else
   {
      posTjd = "1";
      document.getElementById("DESC").innerHTML = "&nbsp;"+kodApp+" : voie directe";
   }
   if ( angApp == '' )
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posTjd+'.png';
   }
   else
   {
      document.images['img'+kodApp].src=imgWeb+imgApp+'_E'+posTjd+'_'+angApp+'.png';
   }
   xhr.open("GET", "/update?output="+kodApp+":J&state="+posTjd, true);
   xhr.send();
   return posTjd;
}

</script>
</body>
</html>
)rawliteral";

// Prise en compte du fichier source du TCO
/*********************************************************************/
#define TCO4
#ifdef TCO1
#include "Mon_TCO_No01.h"
#endif
#ifdef TCO2
#include "Mon_TCO_No02.h"
#endif
#ifdef TCO3
#include "PO-Midi1.h"
#endif
#ifdef TCO4
#include "Mon_TCO_No04.h"
#endif

/*********************************************************************/
void AfficheAppareil(int no_App) 
/*********************************************************************/
{
  char typApp = t_App[no_App].typApp;
  char etaApp = t_App[no_App].etaApp;
  
  if (typApp == 'A') 
  {
     switch (etaApp) 
     {
       case '1' :  
          Serial.println ("Voie directe");
          break; 
       default :          
          Serial.println ("Voie déviée");
          break; 
     }
  }
  else if (typApp == 'S') 
  {
     switch (etaApp) 
     {
       case '1' :  
          Serial.println ("Voie déviée à gauche");
          break; 
       default :          
          Serial.println ("Voie déviée à droite");
          break; 
     }
  }
  else if (typApp == 'T') 
  {
     switch (etaApp) 
     {
       case '1' :  
          Serial.println ("Voie directe");
          break; 
       case '2' :  
          Serial.println ("Voie déviée à gauche");
          break; 
       default :          
          Serial.println ("Voie déviée à droite");
          break; 
     }
  }
  else if (typApp == 'J') 
  {
     switch (etaApp) 
     {
       case '1' :  
          Serial.println ("Voie directe");
          break; 
       case '2' :  
          Serial.println ("Voie déviée");
          break; 
       case '3' :  
          Serial.println ("Voie directe");
          break; 
       default :          
          Serial.println ("Voie déviée");
          break; 
     }
  }
}

/*********************************************************************/
void ActionneAppareil(int no_App) 
/*********************************************************************/
{
  char typApp = t_App[no_App].typApp;
  char etaApp = t_App[no_App].etaApp;
  
  int      no_Mot1 = t_App[no_App].noMot1 - 1;            // No 1er moteur
  int      no_Mot2 = t_App[no_App].noMot2 - 1;            // No 2me moteur
  int      nb_Dek1 = no_Mot1 + no_Mot1;
  int      nb_Dek2 = no_Mot2 < 0 ? 0 : no_Mot2 + no_Mot2;
  uint16_t w_Msk1  = ~(k_Msk >> nb_Dek1);
  uint16_t w_Msk2  = ~(k_Msk >> nb_Dek2);
  uint16_t w_Data;

  if (typApp == 'A')                                      // Aiguille simple
  {
    if (etaApp == '1')
    { 
      w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
    }
    else
    { 
      w_Data = (u_Data & w_Msk1) | (k_Dev >> nb_Dek1);
    }
  }
  else if (typApp == 'S')                                 // Aiguille symétrique
  {
    if (etaApp == '1')
    { 
      w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
    }
    else
    { 
      w_Data = (u_Data & w_Msk1) | (k_Dev >> nb_Dek1);
    }
  }
  else if (typApp == 'T')                                 // Aiguille triple
  {
     switch (etaApp) 
     {
       case '1' :  
          w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dir >> nb_Dek2);
          break; 
       case '2' :  
          w_Data = (u_Data & w_Msk1) | (k_Dev >> nb_Dek1);
          break; 
       default :          
          w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dev >> nb_Dek2);
          break; 
     }
  }
  else if (typApp == 'J')                                 // Traversée jonction
  {
     switch (etaApp) 
     {
       case '1' :  
          w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dir >> nb_Dek2);
          break; 
       case '2' :  
          w_Data = (u_Data & w_Msk1) | (k_Dir >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dev >> nb_Dek2);
          break; 
       case '3' :  
          w_Data = (u_Data & w_Msk1) | (k_Dev >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dev >> nb_Dek2);
          break; 
       default :          
          w_Data = (u_Data & w_Msk1) | (k_Dev >> nb_Dek1);
          w_Data = (w_Data & w_Msk2) | (k_Dir >> nb_Dek2);
          break; 
     }
  }
  else                                                   // rien faire
  {
  }

#ifdef DEBUG 
  (typApp == 'J') ? Serial.print ("Tjd") :  Serial.print ("Aig");
  Serial.print   ( no_App+1 );
  Serial.print   ( " : Av =" );
  Serial.print   ( u_Data, BIN);
  Serial.print   ( "  Ap =" );
  Serial.println ( w_Data, BIN);
#endif

  // Envoi données moteurs aux 74HC595
  //===================================================================
  u_Data = w_Data;
  digitalWrite(verrou, LOW);                  // mettre le verrou
  shiftOut(donnee, horloge, LSBFIRST, u_Data);
  shiftOut(donnee, horloge, LSBFIRST, (u_Data >> 8));
  digitalWrite(verrou, HIGH);                 // oter le verrou
  delay(500);
}

/*********************************************************************/
void CommandeAppareil(const String& nomTyp, const String& etaApp) 
/*********************************************************************/
{
  int    colPos = nomTyp.indexOf(':');
  String nomApp = nomTyp.substring(0, colPos); // nom de l'appareil
  String typApp = nomTyp.substring(colPos+1);  // type de l'appareil (Aig, Tjd, ...
  String numApp = nomTyp.substring(3, colPos); // numéro de l'appareil
  int    no_App = numApp.toInt() - 1;          // ...en indice de table
  t_App[no_App].etaApp = etaApp[0];            // maj état de l'appareil
  
  // Debug : affichage des appareils et de leur état
  //===================================================================
  Serial.print   ( nomApp );
  Serial.print   ( " : " );
  AfficheAppareil(no_App);

  // Actionner les moteurs concernés
  //===================================================================
  ActionneAppareil(no_App);
}

/*********************************************************************/
void InitialiseAppareils() 
/*********************************************************************/
{
  for (int i=0;i < NBMOT;i++)
  {
     if (t_App[i].typApp != ' ')
     {
        ActionneAppareil(i);
     }
  }
}

/*********************************************************************/
void setup()
/*********************************************************************/
{
  // Serial port for debugging purposes
  Serial.begin(115200);

  // les pins pour communiquer avec les 74HC595
  pinMode(horloge, OUTPUT);
  pinMode(verrou,  OUTPUT);
  pinMode(donnee,  OUTPUT);
  InitialiseAppareils();
  Serial.println ( "Initialisation appareils OK " );
  
  // Connect to Wi-Fi
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  // Print ESP Local IP Address
  Serial.println ( "" );
  Serial.print   ( "Maintenant connecte a " );
  Serial.println ( ssid );
  Serial.print   ( "Adresse IP : " );
  Serial.println ( WiFi.localIP() );
  Serial.print   ( "mac Adress : " );
  Serial.println ( WiFi.macAddress() );

  // Route for root / web page
  server.on("/", HTTP_GET, [](AsyncWebServerRequest *request){
    request->send_P(200, "text/html", index_html, processor);
  });

  // Send a GET request to <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
  server.on("/update", HTTP_GET, [] (AsyncWebServerRequest *request) {
    String inputMessage1;
    String inputMessage2;
    // GET input1 value on <ESP_IP>/update?output=<inputMessage1>&state=<inputMessage2>
    if (request->hasParam(PARAM_INPUT_1) && request->hasParam(PARAM_INPUT_2)) 
    {
      inputMessage1 = request->getParam(PARAM_INPUT_1)->value();
      inputMessage2 = request->getParam(PARAM_INPUT_2)->value();

      CommandeAppareil(inputMessage1, inputMessage2);
    }
    else 
    {
      inputMessage1 = "Message ";
      inputMessage2 = "KO";
      Serial.print(inputMessage1);
      Serial.println(inputMessage2);
    }
    
    request->send(200, "text/plain", "OK");
  });

  // Start server
  server.begin();
}

/*********************************************************************/
void loop() 
/*********************************************************************/
{
}
